namespace IrrlichtNetSwig
{
    public partial class arrayVector3df
    {
        public vector3df this[uint index]
        {
            get
            {
                if(index < 0 || size() < index)
                {
                    throw new System.IndexOutOfRangeException();
                }
                return getValue(index);
            }
            set
            {
                if (index < 0 || size() < index)
                {
                    throw new System.IndexOutOfRangeException();
                }
                setValue(index, value);
            }
        }
        public static implicit operator arrayVector3df(vector3df[] other)
        {
            var arr = new arrayVector3df((uint)other.Length);
            for (uint i = 0; i < other.Length; i++)
            {
                arr.push_back(other[i]);
            }
            return arr;
        }
        public vector3df[] ToArray()
        {
            var arr = new vector3df[size()];
            for (uint i = 0; i < size(); i++)
            {
                arr[i] = this.getValue(i);
            }
            return arr;
        }
    }
}